<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareCancelResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PrepareCancelResponse
 * @subpackage Structs
 */
class PrepareCancelResponse extends AbstractResponse
{
    /**
     * The PrepareCancelResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\PrepareCancelResponse
     */
    public $PrepareCancelResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * The FareInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfoCancel
     */
    public $FareInfo;
    /**
     * The SegmentReferencesToCancel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring
     */
    public $SegmentReferencesToCancel;
    /**
     * Constructor method for PrepareCancelResponse
     * @uses PrepareCancelResponse::setPrepareCancelResult()
     * @uses PrepareCancelResponse::setBooking()
     * @uses PrepareCancelResponse::setFareInfo()
     * @uses PrepareCancelResponse::setSegmentReferencesToCancel()
     * @param \App|C\StructType\PrepareCancelResponse $prepareCancelResult
     * @param \App|C\StructType\Booking $booking
     * @param \App|C\StructType\FareInfoCancel $fareInfo
     * @param \App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel
     */
    public function __construct(\App|C\StructType\PrepareCancelResponse $prepareCancelResult = null, \App|C\StructType\Booking $booking = null, \App|C\StructType\FareInfoCancel $fareInfo = null, \App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel = null)
    {
        $this
            ->setPrepareCancelResult($prepareCancelResult)
            ->setBooking($booking)
            ->setFareInfo($fareInfo)
            ->setSegmentReferencesToCancel($segmentReferencesToCancel);
    }
    /**
     * Get PrepareCancelResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\PrepareCancelResponse|null
     */
    public function getPrepareCancelResult()
    {
        return isset($this->PrepareCancelResult) ? $this->PrepareCancelResult : null;
    }
    /**
     * Set PrepareCancelResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\PrepareCancelResponse $prepareCancelResult
     * @return \App|C\StructType\PrepareCancelResponse
     */
    public function setPrepareCancelResult(\App|C\StructType\PrepareCancelResponse $prepareCancelResult = null)
    {
        if (is_null($prepareCancelResult) || (is_array($prepareCancelResult) && empty($prepareCancelResult))) {
            unset($this->PrepareCancelResult);
        } else {
            $this->PrepareCancelResult = $prepareCancelResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\PrepareCancelResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfoCancel|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfoCancel $fareInfo
     * @return \App|C\StructType\PrepareCancelResponse
     */
    public function setFareInfo(\App|C\StructType\FareInfoCancel $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get SegmentReferencesToCancel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring|null
     */
    public function getSegmentReferencesToCancel()
    {
        return isset($this->SegmentReferencesToCancel) ? $this->SegmentReferencesToCancel : null;
    }
    /**
     * Set SegmentReferencesToCancel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel
     * @return \App|C\StructType\PrepareCancelResponse
     */
    public function setSegmentReferencesToCancel(\App|C\ArrayType\ArrayOfstring $segmentReferencesToCancel = null)
    {
        if (is_null($segmentReferencesToCancel) || (is_array($segmentReferencesToCancel) && empty($segmentReferencesToCancel))) {
            unset($this->SegmentReferencesToCancel);
        } else {
            $this->SegmentReferencesToCancel = $segmentReferencesToCancel;
        }
        return $this;
    }
}
